std::regex_iterator::operator*,operator->(3)

NAME
std::regex_iterator::operator*,operator-> - std::regex_iterator::operator*,operator->

Synopsis
   const value_type& operator*() const; (1) (since C++11)
   const value_type* operator->() const; (2) (since C++11)
   Extracts the current std::match_results from a regex_iterator.

Return value
   1) Returns a reference to the current std::match_results.
   2) Returns a pointer to the current std::match_results.

Example
// Run this code
 #include <iostream>
 #include <regex>
 #include <string>
 int main()
 {
     std::string hay{"1.1a2b3cjk34"};
     std::regex needle("[1234]");
     using Ri = std::regex_iterator<std::string::iterator>;
     for (Ri it{hay.begin(), hay.end(), needle}, last{}; it != last; ++it)
         std::cout << it->str();
     std::cout << '\n';
 }

Output:
 112334